// DComServiceClient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "..\DComDemoV1.h"
#include "..\DComDemoV1_i.c"
#include <atlbase.h>
#include <comdef.h>
#include <comutil.h>

int main(int argc, char* argv[])
{
	/* CreateInstance Locally via SmartPointer;
	CComPtr<ISimpleClass> spSimpleClass;
	CoInitialize(NULL);
	HRESULT hr;
	hr=spSimpleClass.CoCreateInstance(__uuidof(SimpleClass));
	if(FAILED(hr))  {printf("Error code:%x",hr);return hr;}

	BSTR result;
	hr=spSimpleClass->HelloWorld(&result);
	if(FAILED(hr))  {printf("Error code:%x",hr);return hr;}

	char* p=::_com_util::ConvertBSTRToString(result);
	printf("%s\n",p);

	::SysFreeString(result);
	CoUninitialize();
	return 0;
	*/
//====================================================
	/*CreateInstance locally via primitive pointer;
	ISimpleClass* pSimpleClass;
	CoInitialize(NULL);
	HRESULT hr;
	hr=CoCreateInstance(CLSID_SimpleClass,0,CLSCTX_LOCAL_SERVER,IID_ISimpleClass,(void**)&pSimpleClass);
	if(FAILED(hr)) return hr;

	BSTR result;
	hr=pSimpleClass->HelloWorld(&result);
	char* p=::_com_util::ConvertBSTRToString(result);
	printf("%s\n",p);

	pSimpleClass->Release();
	CoUninitialize();
	return 0;
	*/

	//call remotely
	
	HRESULT hr;
	ISimpleClass *pI=NULL;

	
	COSERVERINFO sin,*sinptr;

	MULTI_QI mqi;
	mqi.pIID=&IID_ISimpleClass;
	mqi.hr=0;
	mqi.pItf=0;

	COAUTHINFO	authInfo;
	authInfo.dwAuthnSvc = RPC_C_AUTHN_WINNT;//RPC_C_AUTHN_NONE;
	
	authInfo.dwAuthzSvc = RPC_C_AUTHZ_NONE;
	authInfo.pwszServerPrincName = NULL;
	authInfo.dwAuthnLevel = RPC_C_AUTHN_LEVEL_PKT ;//RPC_C_AUTHN_LEVEL_NONE;
	
	authInfo.dwImpersonationLevel =RPC_C_IMP_LEVEL_IMPERSONATE;// RPC_C_IMP_LEVEL_ANONYMOUS;
	
	authInfo.pAuthIdentityData = NULL;
	authInfo.dwCapabilities = NULL;
	

	sin.dwReserved1=0;
	sin.dwReserved2=0;
	sin.pwszName=L"azalea-desk";//define the remote server name here
	sin.pAuthInfo=&authInfo;
	sinptr=&sin;
	
	hr=CoInitialize(0);
	if(SUCCEEDED(hr))
	{
		
		hr=CoCreateInstanceEx(CLSID_SimpleClass,
							NULL,
							CLSCTX_REMOTE_SERVER,
							sinptr,
							1,
							&mqi
							);							
	

		if(SUCCEEDED(hr))
		{
		pI=(ISimpleClass*)mqi.pItf;
		printf("Dcom server connect\n");
		BSTR bsReturnValue;
	
		pI->HelloWorld(&bsReturnValue);
		pI->Release();
		char* pValue=_com_util::ConvertBSTRToString(bsReturnValue);
		printf("%s\n",pValue);	
		delete pValue;
	
		}
		else
		{
			printf("CreateInstance Error!Error Code:%x\n",hr);
		}
	}
	else
	{
		printf("CoInitialize Error!Error Code:%x\n",hr);
	}

	CoUninitialize();
	return 0;
}

